searchNodes=[{"doc":"","ref":"Bakeware.html","title":"Bakeware","type":"module"},{"doc":"Assembler function to be used as a Mix release step This will assemble the necessary components to create a Bakeware executable that can be distributed across machines to run the script/application without extra environment setup (such as installing Elixir/Erlang, etc) To use, add this to your release as a step after assembly: def release do [ demo : [ steps : [ :assemble , &amp; Bakeware . assemble / 1 ] ] ] end Bakeware adds the following options in the release scoped to :bakeware key: :compression_level - Zstandard compression level (1 to 19) where higher numbers generally result in better compression, but are slower to build :start_command - The start script command to run when invoked. This defaults to &quot;start&quot; , but can be changed to &quot;start_iex&quot; , for example, if you want a prompt. See Mix.Release for supported commands. def release do [ demo : [ bakeware : [ compression_level : 1 , start_command : &quot;daemon&quot; ] ] ] end","ref":"Bakeware.html#assemble/1","title":"Bakeware.assemble/1","type":"function"},{"doc":"","ref":"Bakeware.CPIO.html","title":"Bakeware.CPIO","type":"module"},{"doc":"Helper to generate a script that takes command-line arguments Bakeware supports an API similar to Erlang's escript for implementing a main function. Here's an example module: defmodule MyApp.Main do use Bakeware.Script @impl Bakeware.Script def main ( _args ) do IO . puts &quot;Hello, World!&quot; 0 end end The return value sets the scripts exit status (0 for success and other values for errors). Other value types are supported. See :erlang.halt/2 for how these work. Next, add this module to your mix.exs 's application description. This usually looks something like this: def application do [ extra_applications : [ :logger ] , mod : { Myapp.Main , [ ] } ] end Why does the module get added to :mod ? Everything with Bakeware operates on OTP Releases. The macros in Bakeware.Script add the scaffolding to invoke your main/1 function from the release.","ref":"Bakeware.Script.html","title":"Bakeware.Script","type":"behaviour"},{"doc":"Defines an app spec that will execute a script","ref":"Bakeware.Script.html#__using__/1","title":"Bakeware.Script.__using__/1","type":"macro"},{"doc":"","ref":"Bakeware.Script.html#get_argc!/0","title":"Bakeware.Script.get_argc!/0","type":"macro"},{"doc":"","ref":"Bakeware.Script.html#get_args/1","title":"Bakeware.Script.get_args/1","type":"macro"},{"doc":"","ref":"Bakeware.Script.html#c:main/1","title":"Bakeware.Script.main/1","type":"callback"},{"doc":"","ref":"Bakeware.Script.html#result_to_halt/1","title":"Bakeware.Script.result_to_halt/1","type":"macro"},{"doc":"","ref":"Bakeware.Script.html#t:args/0","title":"Bakeware.Script.args/0","type":"type"},{"doc":"Bakeware Compile Elixir applications into single, easily distributed executable binaries Bakeware was made over a weekend at SpawnFest 2020 and thanks to the response from the community, we're working on finishing it off. While it's not ready for production, it's definitely ready for experimentation - just expect APIs to change in the near-term. If you'd like to help, please let us know and stay tuned! Bakeware extends Mix releases with the ability to turn Elixir projects into single binaries that can be copied and directly run. No need to install Erlang or untar files. The binaries look and feel like the build-products from other languages. Here's a quick list of features: Simple - add the bakeware dependency and the Bakeware assembler to your Mix release settings Supports OSX, Linux and Windows (we wrote the code with the BSDs in mind, so support may not be far off) Zstandard compression for smaller binaries Optional support for automatic software updates (work in progress) Command-line argument passing conveniences Lots of examples This README contains the basics of making your applications work with Bakeware and reference material for when you need to dig into how it works. Since everything was written quickly and the integration is fairly straightforward, we recommend that you take a look at the examples. The examples are bare bones Elixir scripts, OTP applications, Phoenix applications and more with small changes to their mix.exs files and instructions for running that you can try out for yourself.","ref":"readme.html","title":"Bakeware","type":"extras"},{"doc":"Mix release Bakeware supports tieing in executable binary assembly into a Mix release as a step by using the Bakeware.assemble/1 function. This will assemble the necessary components to create a Bakeware executable that can be distributed across machines to run the script/application without extra environment setup (such as installing Elixir/Erlang, etc) To use, add this to your release as a step after assembly: def release do [ demo : [ steps : [ :assemble , &amp; Bakeware . assemble / 1 ] ] ] end Bakeware adds the following options in the release scoped to :bakeware key: :compression_level - Zstandard compression level (1 to 19) where higher numbers generally result in better compression, but are slower to build :start_command - The start script command to run when invoked. This defaults to &quot;start&quot; , but can be changed to &quot;start_iex&quot; , for example, if you want a prompt. See Mix.Release for supported commands. def release do [ demo : [ bakeware : [ compression_level : 1 , start_command : &quot;daemon&quot; ] ] ] end Scripting Bakeware supports an API similar to Erlang's escript for implementing a main function. Here's an example module: defmodule MyApp.Main do use Bakeware.Script @impl Bakeware.Script def main ( _args ) do IO . puts &quot;Hello, World!&quot; 0 end end The return value sets the scripts exit status (0 for success and other values for errors). Other value types are supported. See :erlang.halt/2 for how these work. Next, add this module to your mix.exs 's application description. This usually looks something like this: def application do [ extra_applications : [ :logger ] , mod : { Myapp.Main , [ ] } ] end Why does the module get added to :mod ? Everything with Bakeware operates on OTP Releases. The macros in Bakeware.Script add the scaffolding to invoke your main/1 function from the release.","ref":"readme.html#using","title":"Bakeware - Using","type":"extras"},{"doc":"Minimizing executable size Bakeware binaries appear to have a lower bound of about 12 MB in size. We expect that they can be made smaller out-of-the-box, but here are a few things you can do: Make sure zstd is installed to enable compression during assembly: MacOS : brew install zstd Ubuntu : apt-get install zstd Windows : choco install zstandard Build using MIX_ENV=prod . The default is MIX_ENV=dev , so be sure that the environment variable is set. Run rm -fr _build and then mix release . During development cruft builds up in the release directory. Bakeware can't tell the difference between the important files and the cruft, so executables will slowly grow in size if you don't do a clean build. Inspect your _build/prod/rel/&lt;name&gt; directory and especially under lib for files or dependencies that you might be including on accident. Make sure that compile-time dependencies are marked as runtime: false in your mix.exs so that they're not included Try raising the compression Zstandard compression level by setting :compression_level in the mix.exs release config Erlang distribution Bakeware uses Mix releases and inherits the default of starting of Erlang distribution. If you're using Bakeware for commandline or other short-lived applications, this unnecessarily starts Erlang distribution servers running and prevents two application instances from running at a time. To disable, run mix release.init to create starter env.sh.eex and env.bat.eex files in the rel directory. Then edit the files to set RELEASE_DISTRIBUTION=none . Creating cross-platform binaries Bakeware binaries include the Erlang runtime but there are still dependencies on the host system. These include the C runtime and other libraries referenced by the Erlang runtime and any NIFs and ports in your application. Luckily, the binary ABIs of many libraries are very stable, but if distributing to a wide audience, it's useful to build on a system with older library versions. Python has a useful pointers in their packaging guides . Static Compiling OpenSSL into Erlang Distribution Sometimes wierd SSL state bugs arise with a release when openssl is not statically compiled in. You're affected by these ssl issues if you see things like an SSL connection being established but after sending the first packet the remote end drops you. Attached is a Dockerfile that can be built with Podman and used to build your baked released. #Edit the versions of libraries in Dockerfile ENV SSL_VERSION = 1.1 . 1 j ENV OTP_VERSION = OTP - 23.1 . 4 ENV ELIXIR_VERSION = v1 . 11.3 #Build erlang with static openssl podman build -- tag mybuilder DockerfileFolder / #Bake your release podman run - it -- rm - v . :/ root / myproject -- entrypoint bash mybuilder - c &quot;cd /root/myproject &amp;&amp; ./build.sh&quot; #Build.sh export MIX_ENV = prod rm - rf _build mix deps . get mix release cp _build / prod / rel / bakeware / myproject . Building on Windows Bakeware is tested to work in mingw environment on Windows 8 and 10. In order to setup the environment follow these steps: Install chocolatey Install elixir, zstandard, make, and mingw using chocolatey: choco install -y elixir zstandard make mingw Change the default MAKE environment variable used by elixir_make from nmake to make (set it permanently to get rid of the errors in VSCode) Set the CC environment variable Build the release PowerShell $env:MAKE=&quot;make&quot; $env:CC=&quot;gcc&quot; mix release Command Prompt set MAKE = make set CC = gcc mix release MinGW Note: after building the release in MinGW, you need to switch back to PowerShell/CMD to run the application export MAKE=make export CC=gcc mix release","ref":"readme.html#tips","title":"Bakeware - Tips","type":"extras"},{"doc":"Command-line arguments In general, command-line arguments passed to Bakeware applications are passed through to Elixir. A few special command-line arguments can be passed to adjust the launchers behavior. Bakeware stops parsing command-line arguments when it encounters a -- . Processed command-line arguments are not passed along to Elixir. The following arguments may be passed: --bw-info - Print out information about the application and exit --bw-gc - This cleans up all unused entries in the cache (NOT IMPLEMENTED) --bw-install - Unpack the application to the cache only. Do not run. --bw-system-install - Install to a system-wide location (NOT IMPLEMENTED) --bw-command - use the specified Mix.Release command when running the executable Environment variables The Bakeware launcher sets the following environment variables for use in Elixir: Variable name Description BAKEWARE_EXECUTABLE The absolute path to the executable BAKEWARE_ARG1 The first command-line argument BAKEWARE_ARGn The nth command-line argument BAKEWARE_ARGC The number of arguments See the Scripting section of this document for a more user friendly API. Binary format Bakeware application binaries look like this: Bakeware application launcher A CPIO archive of an Erlang/OTP release Trailer The CPIO archive can be compressed. This depends on the contents of the trailer. Trailer format (multi-byte fields are big endian): Offset from end Field Type Description -4 Magic 4 byte string Set to &quot;BAKE&quot; -5 Trailer version 8-bit integer Set to 1 -6 Compression 8-bit integer 0 = No compression, 1 = Zstandard -8 Flags 16-bit integer Set to 0 (no flags yet) -12 Contents offset 32-bit integer Offset of CPIO archive -16 Contents length 32-bit integer Length of CPIO archive -48 SHA1 20 bytes SHA-1 of the CPIO archive","ref":"readme.html#reference-material","title":"Bakeware - Reference material","type":"extras"},{"doc":"Bakeware maintains a cache of extracted binaries. This is needed to run the OTP releases and it enables start-time optimizations. The default cache directory location is system-specific: Windows - &quot;C:/Users/&lt;USER&gt;/AppData/Local/Bakeware/cache&quot; MacOS - &quot;~/Library/Caches/Bakeware&quot; Linux and other Unixes - &quot;~/.cache/bakeware&quot; You can override it by setting the $BAKEWARE_CACHE environment variable. Here's the layout of each cache entry: Path Created by Description $CACHE_DIR/$SHA1/bin CPIO OTP release's bin directory $CACHE_DIR/$SHA1/erts-x.y.z CPIO OTP release's ERTS $CACHE_DIR/$SHA1/lib CPIO OTP release's lib directory $CACHE_DIR/$SHA1/releases CPIO OTP release's releases directory $CACHE_DIR/$SHA1/start CPIO Start script. E.g., bin/my_otp_release start","ref":"readme.html#cache-directory","title":"Bakeware - Cache directory","type":"extras"},{"doc":"All code is licensed under Apache-2.0 with the exception of zstd which is dual licensed BSD/GPL. See it's LICENSE and COPYING files for more details.","ref":"readme.html#license","title":"Bakeware - LICENSE","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Added reduce Makefile prints Fixed Fix mkdir on windows (#128 - thanks @Fl4m3Ph03n1x) Use initial 'for' loop delcarations for systems without C99 mode set","ref":"changelog.html#v0-2-3","title":"Changelog - v0.2.3","type":"extras"},{"doc":"Fixed Allow spaces in bakeware path within start.bat Fix windows path when compressing","ref":"changelog.html#v0-2-2","title":"Changelog - v0.2.2","type":"extras"},{"doc":"Fixed Compilation for Windows MinGW users","ref":"changelog.html#v0-2-1","title":"Changelog - v0.2.1","type":"extras"},{"doc":"Breaking Changes: Applicable release options in mix.exs are now scoped to a :bakeware key. If you were setting :compression_level previously, you will need to update you setting. Enhancements: Windows Support! (Thanks @kritarthh :tada:) - See Building on Windows for more info Adds the :start_command option to the bakeware mix release options which allows you to start the bakeware executable with the same commands supported by Mix.Release . See the bakeware iex_prompt example for how this is used so that the IEx prompt supports line editing. Adds the --bw-command option when running the executable. See mix release command options . Instructions added for compiling static OpenSSL when needed (thanks @vans163) Bug Fixes: Removes mix bakeware.assemble task which is unused and broken (Thanks @christhekeele). Please use mix release for the same effect","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"Bug fixes: Fix an archive creation error that would result in an archive that would fail to unpack. Fix a segfault when passing an internal command line parameter to the archive","ref":"changelog.html#v0-1-5","title":"Changelog - v0.1.5","type":"extras"},{"doc":"This release doesn't change much externally. Internally, we've started cleaning up the code and adding tests to make Bakeware easier for us to maintain. If you have existing Bakeware projects, you may also be interested in our example updates to turn off Erlang distribution and remove the verbose mix release instructions. Bug fixes: Running the same Bakeware archive at or near the same time now works. Previously, it was possible for multiple instances to collide when extracting.","ref":"changelog.html#v0-1-4","title":"Changelog - v0.1.4","type":"extras"},{"doc":"Bug fixes: Fix hex package to include zstd source.","ref":"changelog.html#v0-1-3","title":"Changelog - v0.1.3","type":"extras"},{"doc":"Bug fixes: Fix script startup crash when testing locally (#66)","ref":"changelog.html#v0-1-2","title":"Changelog - v0.1.2","type":"extras"},{"doc":"Initial release to hex. This release is ok for experimentation, but it not intended for production use. It has known issues with script and extraction cache handling.","ref":"changelog.html#v0-1-1","title":"Changelog - v0.1.1","type":"extras"}]